(* Time-stamp: <modified the 13/12/2012 (at 11:32) by Erwan Jahier> *)

(** Performs static evaluations of predefined operators in type expressions *)

type typer = Lic.type_ AstPredef.evaluator

exception EvalType_error of string
(** val type_error : Lic.type_ list -> string -> 'a *)
val raise_arity_error : string -> int -> int -> 'b

val raise_type_error : Lic.type_ list -> Lic.type_ list -> string -> 'a

(** Provides the type profile of predef operators. More precisely,
    given an operator and a list of types, This function checks that
    the provided types are ok, and returns the list of the operator
    output types.
*)
val f : Lic.id_solver -> AstPredef.op -> Lxm.t -> Lic.static_arg list -> typer


(** Does not work for NOR_n and DIESE_n! *)
(** PIS ALLER : 2 versions
   - une pour les macros, qui nécessite un Lic.id_solver pour traiter les Lic.static_arg list
   - l'autre pour les noeuds simple qui peut être utilisée statiquement
*)
val make_node_exp_eff : 
  Lic.id_solver -> bool option -> AstPredef.op -> Lxm.t -> Lic.static_arg list -> Lic.node_exp

val make_simple_node_exp_eff : 
  bool option -> AstPredef.op -> Lxm.t -> Lic.node_exp
